/*
        LanMon.
      TMap.   
     :
  1.      ""    .
                
      "Variables".
  2.     .    
     Maps  TMaps.

     TMap:
  - Caption -  
  - Color -  
  - Visible -   

  - Count -     
  - Items[] -     TMonControl ( 0  Count)

  - A1,A2,A3,A4 -    "",  .
  - Name -  
  - Bitmap -      
  - Sound -   ,   

  - Ohrana -   
  - Tag -   int     Run-Time

  ()   12.08.2005
  www.mnppsaturn.ru
*/

//*****************************************************************************
//          
//*****************************************************************************
bool Func1()
{
  if( Maps.Count==0 ) return false;
  //
  TMap p;
  Variant v[5];
  for(int i=0; i<Maps.Count; i++)
  {
    p = Maps.Items[i];
    //
    v[0] = p.Name;
    if( p.Visible ) v[1] = ""; else v[1] = "";
    v[2] = p.Count;
    if( p.Ohrana ) v[3] = ""; else v[3] = "";
    print( Format(": \"%s\" : %s - : %d  : %s", v) );
  }
  return true;
}
//*****************************************************************************
//     
//*****************************************************************************
String GetObjectTypeText(int ObjType)
{
  switch( ObjType )
  {
    case 1: return "TMonStd";
    case 2: return "TMonText";
    case 3: return "TMonShape";
    case 4: return "TMonImage";
    case 8: return "TMonGraph";
    case 9: return "TMonGauge";
    case 11: return "TBasText";
    case 12: return "TMonList";
    case 13: return "TFRText";
    case 15: return "TMonRegion";
    default: return "    !";
  }
}
//*****************************************************************************
//          
//    MapIndex
//*****************************************************************************
bool Func2(int MapIndex)
{
  if( MapIndex >= Maps.Count ) return false;
  TMap m = Maps.Items[MapIndex];
  //
  print("  , :");
  print(m.Count);

  Variant v[9];
  TMonControl p;
  for(int i=0; i<m.Count; i++)
  {
    p = m.Items[i];

    //       Variant   .
    v[0] = p.A1;
    v[1] = p.A2;
    v[2] = p.A3;
    v[3] = p.A4;
    v[4] = GetObjectTypeText(p.Type);
    v[5] = DateTimeToStr(p.Time);
    v[6] = p.State;
    v[7] = VarToStr(p.Value);
    v[8] = LMFormatString(p.A1,p.A2,p.A3,p.A4,"%A1.%A2.%A3.%A4");

    print( Format("ADDR=%u.%u.%u.%u  OBJTYPE=\"class %s\"  TIME=%s  STATE=%u  VALUE=%s  NAME=\"%s\"", v) );
  }

  return true;
}
//*****************************************************************************
//       Tag     MapIndex
//*****************************************************************************
TMonControl FindObjectByTag(int MapIndex, int Tag)
{
  TMap p = Maps.Items[MapIndex];
  if( p )
  {
    //     MapIndex ...
    for(int i=0; i<p.Count; i++)
    {
      if( p.Items[i].Tag == Tag ) return p.Items[i];
    }
  }
  return nil;
}
//*****************************************************************************
//      A1,A2,A3,A4  
//        -    
//*****************************************************************************
TMonControl FindObjectByAddr(int A1, int A2, int A3, int A4)
{
  TMap p;
  for(int j=0; j<Maps.Count; j++)
  {
    p = Maps.Items[j];
    //     MapIndex ...
    for(int i=0; i<p.Count; i++)
    {
      if( (p.Items[i].A1==A1) && (p.Items[i].A2==A2) &&
          (p.Items[i].A3==A3) && (p.Items[i].A4==A4) ) return p.Items[i];
    }
  }
  return nil;
}
//*****************************************************************************
//    : main()
//*****************************************************************************
{
  //-----------------------------------------------------------------------
  //     
  //-----------------------------------------------------------------------
  if( Func1() )
  {
    print("");
  }
  else
  {
    print("    !");
  }
  //-----------------------------------------------------------------------
  //         1
  //-----------------------------------------------------------------------
  if( Func2(1) )
  {
    print("");
  }
  else
  {
    print("    !");
  }
  //-----------------------------------------------------------------------
  //     ...
  //-----------------------------------------------------------------------
  if( Maps.Count > 0 )
  {
    //        
    if( Length(Maps.Items[0].Sound) > 0 )
    {
      if( Sound.Play(Maps.Items[0].Sound) )
      {
        print("   0     .");
      }
    }
  }
  //-----------------------------------------------------------------------
  //  ,    1.1.1.1  ...
  //-----------------------------------------------------------------------
  TMonControl p = FindObjectByAddr(1, 1, 1, 1);
  if( p )
  {
    //     
    print(" : \"" + p.Name + "\"");
  }
}

